<?php
//======================================================================================
//
//	jQuery fundamentals  part 3
//
//	Function: Get data from server
//
//======================================================================================
?>


<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-loose.dtd value="
<html>
<head>

<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  
	
	<!-- Get the jQuery library -->
	<script type="text/javascript" src="javascript/jquery.min.js"></script>
	
<style>	


.roundCorners {
	-moz-border-radius: 5px;
	-webkit-border-radius: 5px;
	border-radius: 5px 5px 5px 5px;
}

.statusClassOnline {
	width:10px;
	height:10px;
	background-color: green;
}

.statusClassOffline {
	width:10px;
	height:10px;
	background-color: red;
}

.hidden {
	display: none;
}

</style>	
  
<script language="JavaScript" type="text/javascript"> 
//======================================================================================
// Set global variable(s)
//======================================================================================

	var global_interval_timer = 5000;
	var current_timestamp = 'none';

//======================================================================================
// Get status
//======================================================================================
function getStatus( mode ) {

	firstTime = false;
	
	$('#entermessage').slideUp('slow',function() {
		// Call back function
	});
	
	// If auto mode count number of fetches
	if ( mode == '1' ) {
		 var counter = $('#counter').val();
		 counter++
		$('#counter').val(counter);		
		$('#current_count').html(' (Number of updates so far: <b>' +  counter + '</b>)');
	} else {
		 var counter = '';
	}
	
	// Get server mode
	parms = 'servermode=' + $('#modebutton').val();


	$.ajax({
		type: "GET",
		url: 'proxy-connection.php',
		data: parms,
		dataType: 'xml',
		cache: false,			
		success: function( dataStream ) {
		
			$(dataStream).find('data').each(function(){
				current_timestamp = $(this).find('update').attr('timestamp');
			});		
			
			$('#lastupdate').html('Last update: <i>' + current_timestamp + '</i>');
	

			// Parse XML
			$(dataStream).find('userdata').each(function(){
			
				if ( firstTime == false ) {
					$("#data").html( '<tr bgcolor="#999999"><td>' + 'User ID' + '</td><td>' + 'User Name' + '</td><td>' + 'Online' + '</td><td>' + 'Check in date' + '</td><td>' + 'Check in time' + '</td><td>' + 'Message' + '</td></tr>');
					firstTime = true;					
				}
				
				var user = $(this).find('user').text();
				var name = $(this).find('name').text();
				var activ = $(this).find('activ').text();
				var cdate = $(this).find('cdate').text();
				var ctime = $(this).find('ctime').text();
				

				if ( activ == 'Y' ) {
					var onlineStatus = '<div title="activ=' + activ + '" class="statusClassOnline roundCorners">&nbsp;</div>'
					var sendMsgButton = '<button onclick="ShowMessage()">Write Message</button>';
				} else {
					var onlineStatus = '<div title="activ=' + activ + '" class="statusClassOffline roundCorners">&nbsp;</div>'
					var sendMsgButton = '<button class="setDisabled">Write Message</button>';
				}
				
				// Write out the data returned
				$("#data").last().append( '<tr><td>' + user + '</td><td>' + name + '</td><td align="center">' + onlineStatus + '</td><td>' + cdate + '</td><td>' + ctime + '</td><td>' + sendMsgButton + '</td></tr>');
		
			});		
			

		},
			error:function (xhr, ajaxOptions, thrownError){		
			
			// Error handling goes here...

		},
		
			complete:function (){		
			
			if ( mode == '1' ) {
				fadeValue = 1.0  // If auto do not fade
			} else {
				fadeValue = 0.4
			}
			
			// When ajax call done - fade send messages buttons for users that are offline and when 
			// fading is done - use callback function to disable the buttons
			$('.setDisabled').fadeTo('slow', fadeValue, function() {
				$( ".setDisabled" ).attr("disabled", true);
			});
			
			// If manual fetch show message
			if ( mode == '0' ) {
				$("#message").html('Data fetched...');					
			}


		}		
			
	});
	

}

//======================================================================================
// Update
//======================================================================================
function startAutoUpdate() {

	$("#message").html('Auto update running with an interval of ' + global_interval_timer/1000 + ' seconds...');		
	getStatus('1')
	
	$('#startbutton').attr("disabled", true);
	$('#refreshbutton').attr("disabled", true);
	$('#stopbutton').attr("disabled", false);

	myVar=setInterval(function(){getStatus('1')},global_interval_timer);

}

//======================================================================================
// Stop auto update
//======================================================================================
function stopAutoUpdate() {

	$('#startbutton').attr("disabled", false);
	$('#refreshbutton').attr("disabled", false);
	$('#stopbutton').attr("disabled", true);

	$("#message").html('Auto update stopped...');		
	clearInterval(myVar);
	$('#current_count').text('');
	$('#counter').val('0');
}


//======================================================================================
// Show message area
//======================================================================================
function ShowMessage() {

	$('#entermessage').slideDown('slow',function() {
		$("#message").html('Please enter a message...');					
	});	

}


//======================================================================================
// Send message 
//======================================================================================
function SendMessage() {

	$('#entermessage').slideUp('slow',function() {
		$("#message").html('Message sent...');					
	});

}

//======================================================================================
// Close message 
//======================================================================================
function CancelMessage() {

	$('#entermessage').slideUp('slow',function() {
		$("#message").html('Message closed...');
	});

}

//======================================================================================
// Set mode
//======================================================================================
function setMode() {

	if ( $('#modebutton').val() == 'Local' ) {
		$('#modebutton').val('Server');
	} else {
		$('#modebutton').val('Local');
	}

}

//=====================================================================================
// Page loaded
//=====================================================================================
$(document).ready(function() { 

});	
//======================================================================================
  
</script>
  
</head>
<body>

<table width="800" border="0" cellpadding="3" cellspacing="0">
<tr bgcolor="#e8e8e8">
<td colspan="1" align="left">
<input class="button" id="refreshbutton" type="button" value="Check Connection" onclick="getStatus('0')">
<input class="button" id="startbutton" type="button" value="Start auto update" onclick="startAutoUpdate()">
<input class="button" id="stopbutton" type="button" value="Stop auto update" onclick="stopAutoUpdate()">
</td>

<td align="right">
<input class="button" id="modebutton" type="button" value="Local" onclick="setMode()">
</td>
</tr>
<tr>
<td colspan="2">

<table border="1" width="100%" id="data" cellpadding="3" cellspacing="0">
</table>

</td>

</tr>
</table>

<hr>
<span id="message">&nbsp;</span><span id="current_count"></span>
<div id="lastupdate"></div>
<hr>

<input type="hidden" id="counter" value="0">

<div id="entermessage" class="hidden">

<textarea rows="10" cols="60">
Message goes here...
</textarea> 
<br>
<input type="button" onClick="SendMessage()" value="Send message">
<input type="button" onClick="CancelMessage()" value="Cancel message">

</div>

</body>
</html>